function PrimeUI:SetupMoraleBar(data, parent)
    local valuebar = Turbine.UI.Window()
    valuebar:SetParent(parent)
    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or  "Morale Bar")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        valuebar:SetPosition(self:ContentAlignement(data["Alignment"], data["Width"] + 2 * data["BorderSize"]), self.currentHeight)
    end
    valuebar:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar:SetMouseVisible(false)
    valuebar:SetVisible(true)
    valuebar:SetBackColor(self:ColourTupleToTurbineColour(data["BorderColour"]))

    local colour = self:ColourTupleToTurbineColour(data["Colours"])
    if data.Use_Class_Colours then
        local ClassColours = {
            [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(77/255, 38/255, 0), --Yellow
            [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0, 255/255, 152/255), 
            [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(255/255, 244/255, 104/255), --Yellow
            [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(244/255, 140/255, 186/255), --Pink
            [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(198/255, 155/255, 109/255), --Brownrgb(204, 153, 102)
            [(Turbine.Gameplay.Class.Mariner or Turbine.Gameplay.Class.Corsair or Turbine.Gameplay.Class.Chicken)] = Turbine.UI.Color(0, 63/255, 63/255), --Brownrgb(204, 153, 102)
            [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(100/255, 0/255, 0/255), --Red
            [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(170/255, 211/255, 114/255), --{Turbine.UI.Color(51/255, 102/255, 0)
            [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(1, 60/255, 60/255, 115/255), --Purple
            [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0, 60/255, 200/255), --Light green
            [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0, 191/255, 1), --{Turbine.UI.Color(0, 115/255, 153/255),
            [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(255/255, 102/255, 0/255), --Orange
            [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(102/255, 0, 0),
            [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(102/255, 0, 0),
        }
        
        local ClassColoursBackground = {
            [Turbine.Gameplay.Class.BlackArrow] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Beorning] = Turbine.UI.Color(0.5, 77/255, 38/255, 0), --Yellow
            [Turbine.Gameplay.Class.Brawler] = Turbine.UI.Color(0.5, 0, 255/255, 152/255), 
            [Turbine.Gameplay.Class.Burglar] = Turbine.UI.Color(0.3, 255/255, 244/255, 104/255), --Yellow
            [Turbine.Gameplay.Class.Captain] = Turbine.UI.Color(0.5, 244/255, 140/255, 186/255), --Pink
            [Turbine.Gameplay.Class.Champion] = Turbine.UI.Color(0.5, 198/255, 155/255, 109/255), --Brownrgb(0.5, 204, 153, 102)
            [(Turbine.Gameplay.Class.Mariner or Turbine.Gameplay.Class.Corsair or Turbine.Gameplay.Class.Chicken)] = Turbine.UI.Color(0.5, 0, 63/255, 63/255), --Brownrgb(0.5, 204, 153, 102)
            [Turbine.Gameplay.Class.Chicken] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Defiler] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Guardian] = Turbine.UI.Color(0.5, 100/255, 0/255, 0/255), --Red
            [Turbine.Gameplay.Class.Hunter] = Turbine.UI.Color(0.5, 170/255, 211/255, 114/255), --{Turbine.UI.Color(0.5, 51/255, 102/255, 0)
            [Turbine.Gameplay.Class.LoreMaster] = Turbine.UI.Color(0.5, 60/255, 60/255, 115/255), --Purple
            [Turbine.Gameplay.Class.Minstrel] = Turbine.UI.Color(0.5, 0, 60/255, 200/255), --Light green
            [Turbine.Gameplay.Class.Ranger] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Reaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.RuneKeeper] = Turbine.UI.Color(0.5, 63/255, 199/255, 235/255), --Red--Turbine.UI.Color(0.5, 0, 191/255, 1), --{Turbine.UI.Color(0.5, 0, 115/255, 153/255),
            [Turbine.Gameplay.Class.Stalker] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Troll] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Warden] = Turbine.UI.Color(0.5, 255/255, 102/255, 0/255), --Orange
            [Turbine.Gameplay.Class.WarLeader] = Turbine.UI.Color(0.5, 102/255, 0, 0),
            [Turbine.Gameplay.Class.Weaver] = Turbine.UI.Color(0.5, 102/255, 0, 0),
        }
        colour[2] = ClassColours[self.player:GetClass()]
        colour[1] = ClassColoursBackground[self.player:GetClass()]
    end
    

    -- args (parent, x, y, width, height, textFormat, textAlignment, barAlignment, barColours, barbackground)
    local moralebar = ClassSpecificTools.PermanentBar(valuebar, data["BorderSize"], data["BorderSize"], data["Width"], data["Height"], data["Text"], Turbine.UI.ContentAlignment[data.TextAlignment], data["Alignment"], colour, "bar25", self:FontToFont(data["Font"]), self:ColourTupleToTurbineColour(data["Interval_Colour"]), data["Intervals"])
    moralebar:SetMaxValue(self.player:GetMaxMorale())
    moralebar:SetCurrentValue(self.player:GetMorale())
    moralebar:SetTempValue(self.player:GetTemporaryMorale())
    self.lookup[data.NickName or ""] = moralebar
    if data.Disable_Player_Vitals then
        Turbine.UI.Lotro.LotroUI.SetEnabled(Turbine.UI.Lotro.LotroUIElement.Vitals, false)
    else
        Turbine.UI.Lotro.LotroUI.SetEnabled(Turbine.UI.Lotro.LotroUIElement.Vitals, true)
    end

    valuebar.entityControl = Turbine.UI.Lotro.EntityControl()
    valuebar.entityControl:SetParent(valuebar)
    valuebar.entityControl:SetSize(data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"])
    valuebar.entityControl:SetEntity(self.player)

    if data["Smooth"] then
        table.insert(self.playerMoraleHandlerCallbacks, AddCallback(PlayerHandlerObject, "MoraleChanged", function(args) 
            moralebar:SetMaxValue(args.Player_Max_Morale)
            moralebar:SetCurrentValue(args.Player_Morale) 
        end))
    else
        table.insert(self.playerMoraleHandlerCallbacks, AddCallback(PlayerHandlerObject, "MoraleChanged", function(args) 
            moralebar:SetMaxValue(args.Player_Max_Morale)
            moralebar:SetCurrentValueImmediate(args.Player_Morale) 
        end))
    end
    --table.insert(self.playerMaxMoraleHandlerCallbacks, AddCallback(PlayerHandlerObject, "MaxMoraleChanged", function(args) moralebar:SetMaxValue(args.Player_Max_Morale) end))
    table.insert(self.playerTemporaryMoraleHandlerCallbacks, AddCallback(PlayerHandlerObject, "TemporaryMoraleChanged", function(args) moralebar:SetTempValue(args.Player_Temporary_Morale) end))

    moralebar:SetCurrentValue(self.player:GetMorale())
    moralebar:SetMaxValue(self.player:GetMaxMorale())

    if tablelength(data["Highlight_On_Effect"]) > 0 then
        valuebar.effectHighlightCount = 0
        valuebar.effectIDs = {}
        valuebar.highlightFrame = ClassSpecificTools.HighlightFrame3(valuebar, 0, 0, data["Width"] + 2 * data["BorderSize"],  data["Height"] + 2 * data["BorderSize"], self:ColourTupleToTurbineColour(data.Highlight_Colour), 2)

        valuebar.effectFunction = function(effect)
            if data["Highlight_On_Effect"][effect:GetName()] then
                valuebar.effectHighlightCount = valuebar.effectHighlightCount + 1
                valuebar.effectIDs[effect:GetID()] = true
                if  valuebar.effectHighlightCount == 1 then
                    valuebar.highlightFrame:ToggleHighlight(true)
                end
            end
        end


        for i = 1, self.player:GetEffects():GetCount() do
            valuebar.effectFunction(self.player:GetEffects():Get(i))
        end

        table.insert(self.effectAddedCallbacks, AddCallback(PlayerEffectsHandler, "EffectAdded", valuebar.effectFunction))

        table.insert(self.effectRemovedCallbacks, AddCallback(PlayerEffectsHandler, "EffectRemoved", 
        function(effect)
            local ID = effect:GetID()
            if valuebar.effectIDs[ID] then
                valuebar.effectHighlightCount = valuebar.effectHighlightCount - 1
                if  valuebar.effectHighlightCount == 0 then
                    valuebar.highlightFrame:ToggleHighlight(false)
                end
                valuebar.effectIDs[ID] = nil
            end

        end))
    end

    table.insert(self.UI, valuebar)
    table.insert(self.tools, moralebar)

    self.currentHeight = self.currentHeight + data["Height"] + 2 * data["BorderSize"]
    self.heightSize = self.heightSize + data["Height"] + 2 * data["BorderSize"]
end